<?php
namespace PME\Controllers\Relatorios;

use Zeedhi\Framework\Report\ReportService;
use Zeedhi\Framework\DTO;

class NutrientesCardController extends \Zeedhi\Framework\Controller\Report {

    protected $entityManager;
    protected $birtStrategy;
    protected $utilities;

    public function __construct(ReportService $reportService, $entityManager, $birtStrategy, $utilities) {
        $this->entityManager = $entityManager;
        $this->birtStrategy = $birtStrategy;
        $this->utilities = $utilities;

        parent::__construct($reportService);
    }

    protected $reportMapping = array (
        'PME09100' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09101' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09102' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09103' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "NMFILCENTPME"  => "P_NMFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'NRCARDPME'     => 'P_NRCARDPME',
            'IMPOPC'        => 'P_OPCAO',
            'IMPNDPCAL'     => 'P_NDPCAL',
            'CDFILIAL'      => 'P_CDFILIAL',
            'NMFILIAL'      => 'P_NMFILIAL',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09104' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'CDNUTRIENTE1'  => 'P_CDNUTRIENTE1',
            'CDNUTRIENTE2'  => 'P_CDNUTRIENTE2',
            'CDNUTRIENTE3'  => 'P_CDNUTRIENTE3',
            'CDNUTRIENTE4'  => 'P_CDNUTRIENTE4',
            'CDFILIAL'      => 'P_CDFILIAGRE',
            'NRORG'         => 'P_NRORG',
            )
        ),
        'PME09107' => 
        array (
            'strategy' => 'BIRT',
            'parameterMapping' => 
            array (
            "CDFILCENTPME"  => "P_CDFILCENTPME",
            "CDTIPOCARD"    => "P_CDTIPOCARD",
            'NMTIPOCARD'    => 'P_NMTIPOCARD',
            'PERIODODE'     => 'P_DTPERIINI',
            'PERIODOATE'    => 'P_DTPERIFIN',
            'NRSEQUNUTR'    => 'P_NRSEQUNUTR',
            'LISTATPPRATO'  => 'P_LISTATPRATO',
            'CDNUTRIENTE1'  => 'P_CDNUTRIENTE1',
            'CDNUTRIENTE2'  => 'P_CDNUTRIENTE2',
            'CDNUTRIENTE3'  => 'P_CDNUTRIENTE3',
            'CDNUTRIENTE4'  => 'P_CDNUTRIENTE4',
            'CDNUTRIENTE5'  => 'P_CDNUTRIENTE5',
            'CDNUTRIENTE6'  => 'P_CDNUTRIENTE6',
            'CDNUTRIENTE7'  => 'P_CDNUTRIENTE7',
            'CDNUTRIENTE8'  => 'P_CDNUTRIENTE8',
            'CDFILIAL'      => 'P_CDFILIAGRE',
            'NRORG'         => 'P_NRORG',
            )
        ),
    );

    public function beforeProcessReport(DTO\Request\Row $request, DTO\Response $response) {
        $row = $request->getRow();
        
        $nrorg = $this->utilities->getNrOrg();
        $row['NRORG'] = $nrorg;
        
        if(empty($row['UNIDADE'])){
          $cdfilial = $row['CDFILCENTPME'];  
          $row['NMFILIAL'] = "";
          $row['CDFILIAL'] = "";
        } else{ 
            $cdfilial = $row['UNIDADE']['CDFILIAL'];
            $row['CDFILIAL'] = $cdfilial;
            $row['NMFILIAL'] = $row['UNIDADE']['NMFILIAL'];
        }
        
        $listaNutriProc = $listaNutri = '';
        if(empty($row['CDNUTRIENTE'])) $listaNutri = 'T';
        else {
            foreach($row['CDNUTRIENTE'] as $nutr) {
                $listaNutri .= $nutr['CDNUTRIENTE'].'_';
            }
        }
            
        $sqlParamgeral = "SELECT CDCALORIAS, CDPROTEINA, CDLIPIDIOS, CDCARBOHIDRA, CDACIDGRAXOS, CDACUCARES FROM PARAMGERAL";
        $nutrientes = $this->entityManager->getConnection()->fetchAssoc($sqlParamgeral, []);
        
        if (count($nutrientes) > 0) {
            $listaNutriProc .= $nutrientes['CDCALORIAS'].'_'.$nutrientes['CDPROTEINA'].'_'.$nutrientes['CDLIPIDIOS'].'_'.$nutrientes['CDCARBOHIDRA'].'_'.$nutrientes['CDACIDGRAXOS'].'_'.$nutrientes['CDACUCARES'].'_';
        }
        
        if ($listaNutri === 'T') $listaProcedure = 'T';
        else $listaProcedure = $listaNutri.$listaNutriProc;
        
        $nrSeqNutr = $this->procedureCalcNutr($row, $cdfilial, $listaProcedure);
        $row['NRSEQUNUTR'] = $nrSeqNutr;
        
        
        //if(empty($row['CDNUTRIENTE'])) $row['CDNUTRIENTE'] = $this->getNutrientes($cdfilial);

        if(empty($row['CDTIPOPRAT'])) $row['LISTATPPRATO'] = NULL;
        else $row['LISTATPPRATO'] = join('_', $row['CDTIPOPRAT']);

        if(count($row['CDSERVFILI']) == 0) $row['CDSERVFILI'] = 'T';
        else $row['CDSERVFILI'] = is_array($row['CDSERVFILI']) ? join("_", $row['CDSERVFILI']) : $row['CDSERVFILI'];
        
        if($row['IMPOPC'] === 'T') $row['IMPOPC'] =  'S_N_';
        else $row['IMPOPC'] =  'N';
        
        
        $row['CDNUTRIENTE1'] = null;
        $row['CDNUTRIENTE2'] = null; 
        $row['CDNUTRIENTE3'] = null;
        $row['CDNUTRIENTE4'] = null;
        $row['CDNUTRIENTE5'] = null;
        $row['CDNUTRIENTE6'] = null; 
        $row['CDNUTRIENTE7'] = null;
        $row['CDNUTRIENTE8'] = null;

        if($row['CD_REPORT_CODE'] == 'PME09104' || $row['CD_REPORT_CODE'] == 'PME09107') {
            $nutrienterReport = $this->getNutrientes($cdfilial, $listaNutri, $listaNutriProc);
            $this->setParamNutrientes($row, $nutrienterReport);
        }
        
        $this->birtStrategy->setReportLocale($this->utilities->getLanguage());
        $this->birtStrategy->setReportFormat(strtolower($row['reportFormat']));
    }

    private function procedureCalcNutr($row, $cdfilial, $listaNutri){
      if(count($row['SERVICO']) == 0) $cdservfili = 'T';
      else $cdservfili = join('_', $row['SERVICO']);
      $nrSeqNutr = $this->utilities->callProcedureNutrCard($row['CDFILCENTPME'], $cdfilial, $cdservfili, $listaNutri, '', $row['IMPNDPCAL'], $row['PERIODODE'], $row['PERIODOATE'], $row['CDTIPOCARD']);

      return $nrSeqNutr;
    }

    private function getNutrientes ($cdfilial, $listaNutri, $listaNutriProc) {
        try {
            $sql = "SELECT CDNUTRIENTE, NMNUTRIENTE
    				FROM (
    				  SELECT CDNUTRIENTE, NMNUTRIENTE, 1 ORDEM
                        FROM NUTRIENTE 
                       WHERE (:P_NUTRIENTES = 'T' OR INSTR(:P_NUTRIENTES, CDNUTRIENTE) > 0)
                         AND (NOT(INSTR(:P_NUTRIENTES_PARAM, CDNUTRIENTE) > 0)) 
                        ORDER BY CDNUTRIENTE)
    				WHERE ROWNUM <= 8
    				ORDER BY ORDEM";
            return $this->entityManager->getConnection()->fetchAll($sql, ['P_NUTRIENTES' => $listaNutri, 'P_NUTRIENTES_PARAM' => $listaNutriProc]);
        } catch (\Exception $e) {
            throw $e;
        }
    }

    private function setParamNutrientes($row, $nutrientes) {
        // $nutrientes = $this->utilities->getNutrientes($row['CDFILCENTPME']);
        
        
        $qtdNutri = count($nutrientes);
        if ($qtdNutri > 8) $qtdNutri = 8;
        
        for($x = 1; $x <= $qtdNutri; $x++) {
            $chave = "CDNUTRIENTE$x";
            $row[$chave] = $nutrientes[$x-1]["CDNUTRIENTE"];
        }

        /*if(!empty($nutrientes)) {
            $row['CDNUTRIENTE1'] = $nutrientes[0]["CDNUTRIENTE1"];
            $row['CDNUTRIENTE2'] = $nutrientes[0]["CDNUTRIENTE2"]; 
            $row['CDNUTRIENTE3'] = $nutrientes[0]["CDNUTRIENTE3"];
            $row['CDNUTRIENTE4'] = $nutrientes[0]["CDNUTRIENTE4"];
            $row['CDNUTRIENTE5'] = $nutrientes[0]["CDNUTRIENTE1"];
            $row['CDNUTRIENTE6'] = $nutrientes[0]["CDNUTRIENTE2"]; 
            $row['CDNUTRIENTE7'] = $nutrientes[0]["CDNUTRIENTE3"];
            $row['CDNUTRIENTE8'] = $nutrientes[0]["CDNUTRIENTE4"];
        }else {
            $row['CDNUTRIENTE1'] = null;
            $row['CDNUTRIENTE2'] = null; 
            $row['CDNUTRIENTE3'] = null;
            $row['CDNUTRIENTE4'] = null;
            $row['CDNUTRIENTE5'] = null;
            $row['CDNUTRIENTE6'] = null; 
            $row['CDNUTRIENTE7'] = null;
            $row['CDNUTRIENTE8'] = null;
        }*/
    }
}